#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Windows.Forms;
using HeuristicLab.MainForm;
using HeuristicLab.MainForm.WindowsForms;

namespace HeuristicLab.Clients.OKB {
  [View("OKB Administrator")]
  [Content(typeof(OKBClient), false)]
  public sealed partial class QueryView : AsynchronousContentView {
    public new OKBClient Content {
      get { return (OKBClient)base.Content; }
      set { base.Content = value; }
    }

    public QueryView() {
      InitializeComponent();
    }

    protected override void DeregisterContentEvents() {
      // ...
      base.DeregisterContentEvents();
    }

    protected override void RegisterContentEvents() {
      base.RegisterContentEvents();
      // ...
    }

    protected override void OnContentChanged() {
      base.OnContentChanged();
      if (Content == null) {
        // ...
      } else {
        // ...
      }
      runCollectionView.Content = null;
    }

    protected override void SetEnabledStateOfControls() {
      base.SetEnabledStateOfControls();
      filtersView.Enabled = Content != null;
      refreshButton.Enabled = Content != null;
      showRunsButton.Enabled = Content != null;
      runCollectionView.Enabled = Content != null;
    }

    private void refreshButton_Click(object sender, EventArgs e) {
      runCollectionView.Content = Content.QueryRuns(filtersView.Filters);
    }

    private void showRunsButton_Click(object sender, EventArgs e) {
      MainFormManager.MainForm.ShowContent(OKBClient.Instance.ConvertOKBRunsToOptimizationRuns(runCollectionView.Content));
    }
  }
}
